let export filename =
  let oc =
    open_out_gen [Open_wronly;Open_creat;Open_trunc;Open_binary] 0o751 filename
  in
  output_string oc ("#!" ^ Config.ocamlrun ^ "\n");
  let code_offset = pos_out oc in
  Code.export oc;
  let prim_offset = pos_out oc in
  let code_length = prim_offset - code_offset in
  Prim.export oc;
  let data_offset = pos_out oc in
  let prim_length = data_offset - prim_offset in
  Data.export oc;
  let end_offset = pos_out oc in
  let data_length = end_offset - data_offset in
    Index.export oc [
      (Index.Code, code_offset, code_length);
      (Index.Prim, prim_offset, prim_length);
      (Index.Data, data_offset, data_length)
    ];
    let file_length = pos_out oc in
      close_out oc;
      ignore (code_length, data_length, prim_length, file_length)
;;
